package main

import (
	"crypto/sha256"
	"fmt"
	"io/ioutil"
	"log"
	"os"
	"text/template"
)

const sourceTemplate = `
package dfnpki

const (
{{ range $key, $value := . }}
	{{- $key }} = {{ $value }}
{{ end }}
)

var (
	DFNCertificateList = []string{
		{{ range $key, $value := . }}
		{{- $key }},
		{{ end }}
	}
)
`

var t = template.Must(template.New("code").Parse(sourceTemplate))

func main() {
	var (
		certs = make(map[string]string)
	)

	files, err := ioutil.ReadDir(".")
	if err != nil {
		log.Fatal(err)
	}

	for _, file := range files {
		cbytes, err := ioutil.ReadFile(file.Name())
		if err != nil {
			log.Fatal(err)
		}
		key := fmt.Sprintf("c%x", sha256.Sum256(cbytes))
		certs[key] = fmt.Sprintf("%#v", string(cbytes))
	}

	f, err := os.OpenFile("../ca-certificates-autogenerated.go", os.O_CREATE|os.O_TRUNC|os.O_WRONLY, 0644)
	if err != nil {
		log.Fatal(err)
	}
	defer f.Close()

	t.Execute(f, &certs)
}
